## mingw-w64-libosmscout-2024.06.02.1-1.src.tar.zst

=== OSMScout2/CMakeLists.txt ===
find_package(Qt5LinguistTools)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

string(TIMESTAMP OSMSCOUT_VERSION_STRING "%Y-%m-%d")
set(OSMSCOUT_USER_AGENT "OSMScout demo app %1")

set(HEADER_FILES
    src/Theme.h
    src/AppSettings.h
	)

set(SOURCE_FILES
    src/Theme.cpp
    src/AppSettings.cpp
    src/OSMScout.cpp

    # qml files in CMake sources make it visible in QtCreator
    qml/AboutDialog.qml
    qml/main.qml
    qml/SearchDialog.qml
    qml/MapDownloadDialog.qml
    qml/VoiceDownloadDialog.qml
    qml/custom/MapDialog.qml
    qml/custom/ScrollIndicator.qml
    qml/custom/LineEdit.qml
    qml/custom/LocationSearch.qml
    qml/custom/DialogActionButton.qml
    qml/custom/MapButton.qml
	qml/custom/RoutingStep.qml
	qml/custom/RouteStepIcon.qml
	qml/custom/LaneTurnIcon.qml
	qml/custom/LaneTurns.qml
	qml/custom/Utils.js
	)

# XML files with translated phrases.
# You can add new language translation just by adding new entry here, and run build.
# Newly created *.ts file may be edited by linguist tool.
# Please don't forget to add new *.ts file to Meson-based build.
set(TRANSLATION_TS_FILES
	translations/en.ts
	translations/cs.ts
	)

# source files that may contains translatable phrases (see tr, qsTr, QT_TRANSLATE_NOOP functions)
set(TRANSLATION_SOURCE_FILES
	${SOURCE_FILES}
	../libosmscout-client-qt/src/osmscoutclientqt/RouteDescriptionBuilder.cpp
	)

# See http://doc.qt.io/qt-5/cmake-manual.html
#
# qt5_create_translation macro process translations in two steps:
#
#  - collect available phrases inside TRANSLATION_SOURCE_FILES
#    with lupdate tool and put them into *.ts files if some is missing there.
#
#  - create binary translation files (*.qm) from translated phrases available
#    in *.ts files with lrelease tool
qt_create_translation(TRANSLATION_QM_FILES
		${TRANSLATION_SOURCE_FILES}
		${TRANSLATION_TS_FILES})

qt_add_resources(RESOURCE_FILES res.qrc)

set_property(SOURCE qrc_res.cpp PROPERTY SKIP_AUTOMOC ON)

add_executable(OSMScout2 ${SOURCE_FILES} ${HEADER_FILES} ${RESOURCE_FILES})

target_include_directories(OSMScout2 PRIVATE "src")

target_sources(OSMScout2 PRIVATE ${TRANSLATION_TS_FILES} ${TRANSLATION_QM_FILES})

target_link_libraries(OSMScout2
	OSMScout::OSMScout
	OSMScout::Map
	OSMScout::MapQt
	OSMScout::ClientQt
	Qt::Core
	Qt::Gui
	Qt::Widgets
	Qt::Qml
	Qt::Quick
)

if (QtSvg_FOUND)
	target_link_libraries(OSMScout2 Qt::Svg)
endif()

if (QtPositioning_FOUND)
	target_link_libraries(OSMScout2 Qt::Positioning)
endif()

if(MARISA_FOUND)
    target_include_directories(OSMScout2 PRIVATE ${MARISA_INCLUDE_DIRS})
endif()

# enable QML debuger
if (QT_QML_DEBUG)
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DQT_QML_DEBUG")
endif()

set_target_properties(OSMScout2
		PROPERTIES
		VERSION ${OSMSCOUT_LIBRARY_VERSION}
		SOVERSION ${OSMSCOUT_LIBRARY_VERSION}
		FOLDER "Tools")

if(WIN32)
	create_win32_tool_resource(OSMScout2)
endif()
if(MSVC)
	  visual_studio_qt_helper("OSMScout2")
endif()
if(OSMSCOUT_INSTALL_QT_DLL AND TARGET Qt::windeployqt)
	add_custom_command(TARGET OSMScout2
        POST_BUILD
        COMMAND set PATH=%PATH%$<SEMICOLON>${qt_install_prefix}/bin
        COMMAND Qt::windeployqt --dir "${CMAKE_BINARY_DIR}/windeployqt" "$<TARGET_FILE_DIR:OSMScout2>/$<TARGET_FILE_NAME:OSMScout2>"
    )
endif()

install(TARGETS OSMScout2
		RUNTIME DESTINATION bin
		BUNDLE DESTINATION bin
		LIBRARY DESTINATION lib
		ARCHIVE DESTINATION lib)

# install QM files to correct location - QStandardPaths::AppDataLocation / "translations"
if(APPLE)
	install(FILES ${TRANSLATION_QM_FILES}
			DESTINATION "/Library/Application Support/osmscout/OSMScout2/translations")
elseif(WIN32)
#	install(FILES ${TRANSLATION_QM_FILES}
#			DESTINATION C:/ProgramData/osmscout/OSMScout2/translations)
else() # Linux
	install(FILES ${TRANSLATION_QM_FILES}
			DESTINATION share/osmscout/OSMScout2/translations)
endif()

=== libosmscout-client-qt/CMakeLists.txt ===
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(HEADER_FILES
    include/osmscoutclientqt/ClientQtImportExport.h
    include/osmscoutclientqt/ElevationChartWidget.h
    include/osmscoutclientqt/ElevationModule.h
    include/osmscoutclientqt/FileDownloader.h
    include/osmscoutclientqt/IconAnimation.h
    include/osmscoutclientqt/IconLookup.h
    include/osmscoutclientqt/InputHandler.h
    include/osmscoutclientqt/LocationEntry.h
    include/osmscoutclientqt/LocationInfoModel.h
    include/osmscoutclientqt/MapWidget.h
    include/osmscoutclientqt/OnlineTileProviderModel.h
    include/osmscoutclientqt/OpeningHoursModel.h
    include/osmscoutclientqt/OsmTileDownloader.h
    include/osmscoutclientqt/OSMTile.h
    include/osmscoutclientqt/RoutingModel.h
    include/osmscoutclientqt/Router.h
    include/osmscoutclientqt/SearchLocationModel.h
    include/osmscoutclientqt/TileCache.h
    include/osmscoutclientqt/AvailableMapsModel.h
    include/osmscoutclientqt/PersistentCookieJar.h
    include/osmscoutclientqt/MapDownloader.h
    include/osmscoutclientqt/MapDownloadsModel.h
    include/osmscoutclientqt/MapObjectInfoModel.h
    include/osmscoutclientqt/MapStyleModel.h
    include/osmscoutclientqt/StyleFlagsModel.h
    include/osmscoutclientqt/OSMScoutQt.h
    include/osmscoutclientqt/DBLoadJob.h
    include/osmscoutclientqt/LookupModule.h
    include/osmscoutclientqt/SearchModule.h
    include/osmscoutclientqt/StyleModule.h
    include/osmscoutclientqt/SunriseSunset.h
    include/osmscoutclientqt/MapRenderer.h
    include/osmscoutclientqt/PlaneMapRenderer.h
    include/osmscoutclientqt/TiledMapRenderer.h
    include/osmscoutclientqt/OverlayObject.h
    include/osmscoutclientqt/MapOverlay.h
    include/osmscoutclientqt/TiledMapOverlay.h
    include/osmscoutclientqt/TiledRenderingHelper.h
    include/osmscoutclientqt/NavigationModule.h
    include/osmscoutclientqt/RouteDescriptionBuilder.h
    include/osmscoutclientqt/NavigationModel.h
    include/osmscoutclientqt/VehiclePosition.h
    include/osmscoutclientqt/QmlRoutingProfile.h
    include/osmscoutclientqt/QmlSettings.h
    include/osmscoutclientqt/QtRouteData.h
    include/osmscoutclientqt/QtSettingsStorage.h
    include/osmscoutclientqt/QtStdConverters.h
    include/osmscoutclientqt/RouteStep.h
    include/osmscoutclientqt/NearPOIModel.h
    include/osmscoutclientqt/InstalledMapsModel.h
    include/osmscoutclientqt/Voice.h
    include/osmscoutclientqt/VoiceManager.h
    include/osmscoutclientqt/AvailableVoicesModel.h
    include/osmscoutclientqt/InstalledVoicesModel.h
)

set(SOURCE_FILES
    src/osmscoutclientqt/ElevationChartWidget.cpp
    src/osmscoutclientqt/ElevationModule.cpp
    src/osmscoutclientqt/FileDownloader.cpp
    src/osmscoutclientqt/IconAnimation.cpp
    src/osmscoutclientqt/IconLookup.cpp
    src/osmscoutclientqt/InputHandler.cpp
    src/osmscoutclientqt/LocationEntry.cpp
    src/osmscoutclientqt/LocationInfoModel.cpp
    src/osmscoutclientqt/MapWidget.cpp
    src/osmscoutclientqt/OnlineTileProviderModel.cpp
    src/osmscoutclientqt/OpeningHoursModel.cpp
    src/osmscoutclientqt/OSMTile.cpp
    src/osmscoutclientqt/OsmTileDownloader.cpp
    src/osmscoutclientqt/RoutingModel.cpp
    src/osmscoutclientqt/Router.cpp
    src/osmscoutclientqt/SearchLocationModel.cpp
    src/osmscoutclientqt/TileCache.cpp
    src/osmscoutclientqt/AvailableMapsModel.cpp
    src/osmscoutclientqt/MapDownloader.cpp
    src/osmscoutclientqt/MapDownloadsModel.cpp
    src/osmscoutclientqt/MapObjectInfoModel.cpp
    src/osmscoutclientqt/MapStyleModel.cpp
    src/osmscoutclientqt/StyleFlagsModel.cpp
    src/osmscoutclientqt/OSMScoutQt.cpp
    src/osmscoutclientqt/DBLoadJob.cpp
    src/osmscoutclientqt/LookupModule.cpp
    src/osmscoutclientqt/SearchModule.cpp
    src/osmscoutclientqt/StyleModule.cpp
    src/osmscoutclientqt/SunriseSunset.cpp
    src/osmscoutclientqt/MapRenderer.cpp
    src/osmscoutclientqt/PlaneMapRenderer.cpp
    src/osmscoutclientqt/TiledMapRenderer.cpp
    src/osmscoutclientqt/OverlayObject.cpp
    src/osmscoutclientqt/MapOverlay.cpp
    src/osmscoutclientqt/TiledMapOverlay.cpp
    src/osmscoutclientqt/TiledRenderingHelper.cpp
    src/osmscoutclientqt/NavigationModule.cpp
    src/osmscoutclientqt/RouteDescriptionBuilder.cpp
    src/osmscoutclientqt/NavigationModel.cpp
    src/osmscoutclientqt/VehiclePosition.cpp
    src/osmscoutclientqt/RouteStep.cpp
    src/osmscoutclientqt/QmlRoutingProfile.cpp
    src/osmscoutclientqt/QmlSettings.cpp
    src/osmscoutclientqt/QtRouteData.cpp
    src/osmscoutclientqt/QtSettingsStorage.cpp
    src/osmscoutclientqt/QtStdConverters.cpp
    src/osmscoutclientqt/NearPOIModel.cpp
    src/osmscoutclientqt/InstalledMapsModel.cpp
    src/osmscoutclientqt/Voice.cpp
    src/osmscoutclientqt/VoiceManager.cpp
    src/osmscoutclientqt/AvailableVoicesModel.cpp
    src/osmscoutclientqt/InstalledVoicesModel.cpp
)

if (QT_VERSION_MAJOR EQUAL 6)
	osmscout_library_project(
			NAME OSMScoutClientQt
			ALIAS ClientQt
			OUTPUT_NAME "osmscout_client_qt"
			SOURCE ${SOURCE_FILES}
			HEADER ${HEADER_FILES}
			INCLUDEDIR osmscoutclientqt
			TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/include/osmscoutclientqt/ClientQtFeatures.h.cmake
			TARGET OSMScout::OSMScout OSMScout::Map OSMScout::MapQt Qt::Core Qt6::Core5Compat Qt::Gui Qt::Quick Qt::Multimedia OSMScout::Client
	)
else ()
	osmscout_library_project(
			NAME OSMScoutClientQt
			ALIAS ClientQt
			OUTPUT_NAME "osmscout_client_qt"
			SOURCE ${SOURCE_FILES}
			HEADER ${HEADER_FILES}
			INCLUDEDIR osmscoutclientqt
			TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/include/osmscoutclientqt/ClientQtFeatures.h.cmake
			TARGET OSMScout::OSMScout OSMScout::Map OSMScout::MapQt Qt::Core Qt::Gui Qt::Quick Qt::Multimedia OSMScout::Client
	)
endif ()

if(MARISA_FOUND)
    target_include_directories(OSMScoutClientQt PUBLIC ${MARISA_INCLUDE_DIRS})
    target_link_libraries(OSMScoutClientQt ${MARISA_LIBRARIES})
endif()

if(APPLE AND OSMSCOUT_BUILD_FRAMEWORKS)
	set_target_properties(OSMScoutClientQt PROPERTIES
		FRAMEWORK TRUE
		FRAMEWORK_VERSION C
		MACOSX_FRAMEWORK_IDENTIFIER com.cmake.dynamicFramework
		#MACOSX_FRAMEWORK_INFO_PLIST Info.plist
		PUBLIC_HEADER     "${HEADER_FILES}"
		CODE_ATTRIBUTE_CODE_SIGN_IDENTITY "iPhone Developer"
		OUTPUT_NAME "OSMScoutClientQt")
endif()

=== libosmscout-import/CMakeLists.txt ===
set(HEADER_FILES
    include/osmscoutimport/AreaIndexGenerator.h
    include/osmscoutimport/GenAreaAreaIndex.h
    include/osmscoutimport/GenAreaNodeIndex.h
    include/osmscoutimport/GenAreaWayIndex.h
    include/osmscoutimport/GenCoordDat.h
    include/osmscoutimport/GenCoverageIndex.h
    include/osmscoutimport/GenIntersectionIndex.h
    include/osmscoutimport/GenLocationIndex.h
    include/osmscoutimport/GenMergeAreas.h
    include/osmscoutimport/GenNodeDat.h
    include/osmscoutimport/GenNumericIndex.h
    include/osmscoutimport/GenOptimizeAreasLowZoom.h
    include/osmscoutimport/GenOptimizeAreaWayIds.h
    include/osmscoutimport/GenOptimizeWaysLowZoom.h
    include/osmscoutimport/GenPTRouteDat.h
    include/osmscoutimport/GenRawNodeIndex.h
    include/osmscoutimport/GenRawRelIndex.h
    include/osmscoutimport/GenAreaRouteIndex.h
    include/osmscoutimport/GenRawWayIndex.h
    include/osmscoutimport/GenRelAreaDat.h
    include/osmscoutimport/GenRouteDat.h
    include/osmscoutimport/GenRoute2Dat.h
    include/osmscoutimport/GenTypeDat.h
    include/osmscoutimport/GenWaterIndex.h
    include/osmscoutimport/GenWayAreaDat.h
    include/osmscoutimport/GenWayWayDat.h
    include/osmscoutimport/Import.h
    include/osmscoutimport/ImportErrorReporter.h
    include/osmscoutimport/ImportModule.h
    include/osmscoutimport/ImportParameter.h
    include/osmscoutimport/ImportProgress.h
    include/osmscoutimport/MergeAreaData.h
    include/osmscoutimport/Preprocess.h
    include/osmscoutimport/Preprocessor.h
    include/osmscoutimport/PreprocessPoly.h
    include/osmscoutimport/RawCoastline.h
    include/osmscoutimport/RawCoord.h
    include/osmscoutimport/RawNode.h
    include/osmscoutimport/RawRelation.h
    include/osmscoutimport/RawRelIndexedDataFile.h
    include/osmscoutimport/RawWay.h
    include/osmscoutimport/RawWayIndexedDataFile.h
    include/osmscoutimport/ShapeFileScanner.h
    include/osmscoutimport/WaterIndexProcessor.h
    include/osmscoutimport/SortDat.h
    include/osmscoutimport/SortNodeDat.h
    include/osmscoutimport/SortWayDat.h
    include/osmscoutimport/ImportImportExport.h
)

set(SOURCE_FILES
    src/osmscoutimport/AreaIndexGenerator.cpp
    src/osmscoutimport/GenAreaAreaIndex.cpp
    src/osmscoutimport/GenAreaNodeIndex.cpp
    src/osmscoutimport/GenAreaWayIndex.cpp
    src/osmscoutimport/GenCoordDat.cpp
    src/osmscoutimport/GenCoverageIndex.cpp
    src/osmscoutimport/GenIntersectionIndex.cpp
    src/osmscoutimport/GenLocationIndex.cpp
    src/osmscoutimport/GenMergeAreas.cpp
    src/osmscoutimport/GenNodeDat.cpp
    src/osmscoutimport/GenNumericIndex.cpp
    src/osmscoutimport/GenOptimizeAreasLowZoom.cpp
    src/osmscoutimport/GenOptimizeAreaWayIds.cpp
    src/osmscoutimport/GenOptimizeWaysLowZoom.cpp
    src/osmscoutimport/GenRawNodeIndex.cpp
    src/osmscoutimport/GenRawRelIndex.cpp
    src/osmscoutimport/GenAreaRouteIndex.cpp
    src/osmscoutimport/GenRawWayIndex.cpp
    src/osmscoutimport/GenRelAreaDat.cpp
    src/osmscoutimport/GenPTRouteDat.cpp
    src/osmscoutimport/GenRouteDat.cpp
    src/osmscoutimport/GenRoute2Dat.cpp
    src/osmscoutimport/GenTypeDat.cpp
    src/osmscoutimport/GenWaterIndex.cpp
    src/osmscoutimport/GenWayAreaDat.cpp
    src/osmscoutimport/GenWayWayDat.cpp
    src/osmscoutimport/Import.cpp
    src/osmscoutimport/ImportErrorReporter.cpp
    src/osmscoutimport/ImportModule.cpp
    src/osmscoutimport/ImportParameter.cpp
    src/osmscoutimport/ImportProgress.cpp
    src/osmscoutimport/MergeAreaData.cpp
    src/osmscoutimport/Preprocess.cpp
    src/osmscoutimport/Preprocessor.cpp
    src/osmscoutimport/PreprocessPoly.cpp
    src/osmscoutimport/RawCoastline.cpp
    src/osmscoutimport/RawCoord.cpp
    src/osmscoutimport/RawNode.cpp
    src/osmscoutimport/RawRelation.cpp
    src/osmscoutimport/RawRelIndexedDataFile.cpp
    src/osmscoutimport/RawWay.cpp
    src/osmscoutimport/RawWayIndexedDataFile.cpp
    src/osmscoutimport/ShapeFileScanner.cpp
    src/osmscoutimport/WaterIndexProcessor.cpp
    src/osmscoutimport/SortDat.cpp
    src/osmscoutimport/SortNodeDat.cpp
    src/osmscoutimport/SortWayDat.cpp
)

set(EXCLUDE_HEADER)

if(MARISA_FOUND)
    list(APPEND HEADER_FILES include/osmscoutimport/GenTextIndex.h)
    list(APPEND SOURCE_FILES src/osmscoutimport/GenTextIndex.cpp)
else()
	list(APPEND EXCLUDE_HEADER GenTextIndex.h)
endif()

if(TARGET LibXml2::LibXml2)
    list(APPEND HEADER_FILES include/osmscoutimport/PreprocessOSM.h)
    list(APPEND SOURCE_FILES src/osmscoutimport/PreprocessOSM.cpp)
else()
	list(APPEND EXCLUDE_HEADER PreprocessOSM.h)
endif()

if (TARGET protobuf::libprotobuf AND EXISTS ${PROTOBUF_PROTOC_EXECUTABLE})
	protobuf_generate_cpp(PROTO_SRCS PROTO_HDRS
		${CMAKE_CURRENT_SOURCE_DIR}/src/protobuf/fileformat.proto
		${CMAKE_CURRENT_SOURCE_DIR}/src/protobuf/osmformat.proto)
    list(APPEND HEADER_FILES include/osmscoutimport/PreprocessPBF.h)
    list(APPEND SOURCE_FILES src/osmscoutimport/PreprocessPBF.cpp)
    list(APPEND HEADER_FILES ${PROTO_HDRS})
    list(APPEND SOURCE_FILES ${PROTO_SRCS})
else()
	list(APPEND EXCLUDE_HEADER PreprocessPBF.h ${PROTO_HDRS})
endif()

osmscout_library_project(
	NAME OSMScoutImport
	ALIAS Import
	OUTPUT_NAME "osmscout_import"
	SOURCE ${SOURCE_FILES}
	HEADER ${HEADER_FILES}
	INCLUDEDIR "osmscoutimport"
	TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/include/osmscoutimport/ImportFeatures.h.cmake
	FEATURE ${CMAKE_CURRENT_BINARY_DIR}/include/osmscoutimport/ImportFeatures.h
	TARGET OSMScout::OSMScout
	SKIP_HEADER
)

if(TARGET LibXml2::LibXml2)
	target_link_libraries(OSMScoutImport LibXml2::LibXml2)
endif()

if (TARGET protobuf::libprotobuf AND EXISTS ${PROTOBUF_PROTOC_EXECUTABLE})
	target_include_directories(OSMScoutImport PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
	target_link_libraries(OSMScoutImport protobuf::libprotobuf)
	if(WIN32)
		target_compile_definitions(OSMScoutImport PRIVATE -DPROTOBUF_USE_DLLS)
	endif()
	target_compile_definitions(OSMScoutImport PRIVATE -DOSMSCOUT_IMPORT_CMAKE_BUILD)
endif()

if (TARGET Iconv::Iconv)
	target_link_libraries(OSMScoutImport Iconv::Iconv)
endif()

if (TARGET LibLZMA::LibLZMA)
	target_link_libraries(OSMScoutImport LibLZMA::LibLZMA)
endif()

if (TARGET ZLIB::ZLIB)
	target_link_libraries(OSMScoutImport ZLIB::ZLIB)
endif()

if(MARISA_FOUND)
	target_include_directories(OSMScoutImport PRIVATE ${MARISA_INCLUDE_DIRS})
	target_link_libraries(OSMScoutImport ${MARISA_LIBRARIES})
endif()

if (HAVE_STD_EXECUTION)
	target_link_libraries(OSMScoutImport TBB::tbb)
endif()

if(TARGET OpenMP::OpenMP_CXX)
	target_link_libraries(OSMScoutImport OpenMP::OpenMP_CXX)
endif()

if(APPLE AND OSMSCOUT_BUILD_FRAMEWORKS)
	set_target_properties(OSMScoutImport PROPERTIES
        FRAMEWORK TRUE
        FRAMEWORK_VERSION C
        MACOSX_FRAMEWORK_IDENTIFIER com.cmake.dynamicFramework
        #MACOSX_FRAMEWORK_INFO_PLIST Info.plist
        PUBLIC_HEADER     "${HEADER_FILES}"
        CODE_ATTRIBUTE_CODE_SIGN_IDENTITY "iPhone Developer"
        OUTPUT_NAME "OSMScoutImport")
endif()

if(WIN32)
	target_link_libraries(OSMScoutImport Ws2_32.lib)
endif()

if(NOT EXCLUDE_HEADER)
	install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/osmscoutimport DESTINATION include FILES_MATCHING PATTERN "*.h" PATTERN "private" EXCLUDE)
else()
	set(_exclude PATTERN "private" EXCLUDE)
	foreach(ef ${EXCLUDE_HEADER})
		set(_exclude ${_exclude} PATTERN ${ef} EXCLUDE)
	endforeach()
	install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/osmscoutimport DESTINATION include FILES_MATCHING PATTERN "*.h" ${_exclude})
endif()
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/include/osmscoutimport/ImportFeatures.h DESTINATION include/osmscout)

=== PKGBUILD ===
# Maintainer: Adrian Jaekel <adrian at arteco dot de>

_realname=libosmscout
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=2024.06.02.1
pkgrel=1
pkgdesc="A Library for offline map rendering, routing and location lookup based on OpenStreetMap data (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/Framstag/libosmscout"
license=('spdx:LGPL-2.0-only')
depends=("${MINGW_PACKAGE_PREFIX}-cairo"
         "${MINGW_PACKAGE_PREFIX}-fontconfig"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-freeglut"
         "${MINGW_PACKAGE_PREFIX}-glew"
         "${MINGW_PACKAGE_PREFIX}-glfw"
         "${MINGW_PACKAGE_PREFIX}-glib2"
         "${MINGW_PACKAGE_PREFIX}-glm"
         "${MINGW_PACKAGE_PREFIX}-harfbuzz"
         "${MINGW_PACKAGE_PREFIX}-iconv"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-marisa"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-pango"
         "${MINGW_PACKAGE_PREFIX}-protobuf"
         "${MINGW_PACKAGE_PREFIX}-qt6-5compat"
         "${MINGW_PACKAGE_PREFIX}-qt6-base"
         "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
         "${MINGW_PACKAGE_PREFIX}-qt6-multimedia"
         "${MINGW_PACKAGE_PREFIX}-qt6-positioning"
         "${MINGW_PACKAGE_PREFIX}-qt6-svg"
         "${MINGW_PACKAGE_PREFIX}-xz"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-pkgconf"
             "${MINGW_PACKAGE_PREFIX}-clang-libs"
             "${MINGW_PACKAGE_PREFIX}-qt6-tools")
# imagemagick also installs "bin/import.exe"
conflicts=("${MINGW_PACKAGE_PREFIX}-imagemagick")
source=(https://github.com/Framstag/libosmscout/releases/download/v${pkgver}/libosmscout-${pkgver}.tar.xz
        001-fix-install-destinations.patch)
sha256sums=('6dc4929e24fac27b4a24683599ec46b0faedd77251729a11bd098f670fcaec7e'
            '1b57cf69903dacea4a6854991b83c9523a9f23b98ad39a7b773462802d8860ab')

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}
  patch -p1 -i "${srcdir}"/001-fix-install-destinations.patch
}

build() {
  mkdir "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  if check_option "debug" "y"; then
    _build_type="Debug"
  else
    _build_type="Release"
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake -Wno-dev \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DCMAKE_BUILD_TYPE=${_build_type} \
    -DOSMSCOUT_BUILD_TESTS=OFF \
    -DOSMSCOUT_BUILD_DEMOS=OFF \
    -DOSMSCOUT_INSTALL_QT_DLL=OFF \
    -DDirect2D_D2D1_LIBRARY=${MINGW_PREFIX}/lib/libd2d1.a \
    -DDirect2D_DWRITE_LIBRARY=${MINGW_PREFIX}/lib/libdwrite.a \
    -DQT_VERSION_PREFERRED=6 \
    "../${_realname}-${pkgver}"

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
